-- Bugnot_BibalV2
-- Specialization for Bugnot_BibalV2 mod
--
-- @author  TSF3(newholl)

Bugnot_BibalV2 = {};

function Bugnot_BibalV2.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Attachable, specializations);
end;

function Bugnot_BibalV2:load(xmlFile)


	local Rot1Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Rot1#index"));
    if Rot1Node ~= nil then
        self.Rot1 = {};
        self.Rot1.node = Rot1Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Rot1#minRot"));
        self.Rot1.minRot = {};
        self.Rot1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Rot1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Rot1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Rot1#maxRot"));
        self.Rot1.maxRot = {};
        self.Rot1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Rot1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Rot1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.Rot1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.Rot1#rotTime"), 2)*1000;
    end;
	local Rot2Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Rot2#index"));
    if Rot2Node ~= nil then
        self.Rot2 = {};
        self.Rot2.node = Rot2Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Rot2#minRot"));
        self.Rot2.minRot = {};
        self.Rot2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Rot2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Rot2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Rot2#maxRot"));
        self.Rot2.maxRot = {};
        self.Rot2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Rot2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Rot2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.Rot2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.Rot2#rotTime"), 2)*1000;
    end;
	self.hydraulic = {};
	self.hydraulic.node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.hydraulic#indexHydraulic"));
	self.hydraulic.punch = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.hydraulic#indexPunch"));
	self.hydraulic.translationPunch = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.hydraulic#translationPunch"));
	local ax, ay, az = getWorldTranslation(self.hydraulic.punch);
    local bx, by, bz = getWorldTranslation(self.hydraulic.translationPunch);
    self.hydraulic.punchDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);
	self.hydraulicPoint = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.hydraulic#hydraulicPoint"));
	self.keys = {};
	self.keysDesc = {};
    local i=0;
    while true do
        local baseName = string.format("vehicle.keys.input(%d)", i);
        local inputName = getXMLString(xmlFile, baseName.. "#name");
        if inputName == nil then
            break;
        end;
        local inputKey = getXMLString(xmlFile, baseName.. "#key");
        if Input[inputKey] == nil then
            print("Error: invalid key '" .. inputKey .. "'  for input event '" .. inputName .. "'");
            break;
        end;
        self.keys[inputName] = Input[inputKey];
		self.keysDesc[inputName] = getXMLString(xmlFile, baseName.. "#keyDesc");
        i = i+1;
    end;
    
    local numAttachers = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.Attachers#count"), 0);
	
     self.Attacher = {};
	
	for i=1, numAttachers do
	 local objectAttacher = {};
	 self.Attacher[i] = {};
	 local partnamei = string.format("vehicle.Attachers.objectAttacher".."%d",i);
	 objectAttacher.node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, partnamei .. "#index"));
	 objectAttacher.joint = 0;
	 self.Attacher[i].object = {}; 
	 self.Attacher[i].object = objectAttacher;
	 self.Attacher[i].attachedObject = {}
	 for x=1,4 do
	 self.Attacher[i].attachedObject[x] = nil;
	 end;
	 self.Attacher[i].count = 0;
	 self.Attacher[i].objectInRange = nil;
	end;
    local object = self.Attacher[1].object; 
    self.localObject2 = getChildAt(object.node,0);
    self.localObject3 = getChildAt(object.node,1);
    local object = self.Attacher[2].object; 
    self.localObject4 = getChildAt(object.node,0);
    self.localObject5 = getChildAt(object.node,1);
    local object = self.Attacher[3].object; 
    self.localObject6 = getChildAt(object.node,0);
    self.localObject7 = getChildAt(object.node,1);

    --self.collision1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Collision1#index"));
    --self.collision2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Collision2#index"));

end;

function Bugnot_BibalV2:delete()
end;

function Bugnot_BibalV2:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Bugnot_BibalV2:keyEvent(unicode, sym, modifier, isDown)
end;

function Bugnot_BibalV2:update(dt)

	if self.attacherVehicle ~= nil then
	    if self:getIsActiveForInput() then
			if Input.isKeyPressed(self.keys.fermer) then
              if self.Attacher[1].attachedObject[1] ~= nil then
                local x, y, z = getRotation(self.Rot1.node);
                 if y > -0.911 then

				local x, y, z = getRotation(self.Rot1.node);
		        local rot = {x,y,z};
		        local newRot = Utils.getMovedLimitedValues(rot, self.Rot1.maxRot, self.Rot1.minRot, 3, self.Rot1.rotTime*2, dt, true);
			    setRotation(self.Rot1.node, unpack(newRot));
				local x, y, z = getRotation(self.Rot2.node);
		        local rot = {x,y,z};
		        local newRot = Utils.getMovedLimitedValues(rot, self.Rot2.maxRot, self.Rot2.minRot, 3, self.Rot2.rotTime*2, dt, true);
			    setRotation(self.Rot2.node, unpack(newRot));
               end;
             else

                local x, y, z = getRotation(self.Rot1.node);
		        local rot = {x,y,z};
		        local newRot = Utils.getMovedLimitedValues(rot, self.Rot1.maxRot, self.Rot1.minRot, 3, self.Rot1.rotTime*2, dt, true);
			    setRotation(self.Rot1.node, unpack(newRot));
				local x, y, z = getRotation(self.Rot2.node);
		        local rot = {x,y,z};
		        local newRot = Utils.getMovedLimitedValues(rot, self.Rot2.maxRot, self.Rot2.minRot, 3, self.Rot2.rotTime*2, dt, true);
			    setRotation(self.Rot2.node, unpack(newRot));
               end;

		     end;

			if Input.isKeyPressed(self.keys.ouvrir) then
				local x, y, z = getRotation(self.Rot1.node);
		        local rot = {x,y,z};
		        local newRot = Utils.getMovedLimitedValues(rot, self.Rot1.maxRot, self.Rot1.minRot, 3, self.Rot1.rotTime*2, dt, false);
			    setRotation(self.Rot1.node, unpack(newRot));
				local x, y, z = getRotation(self.Rot2.node);
		        local rot = {x,y,z};
		        local newRot = Utils.getMovedLimitedValues(rot, self.Rot2.maxRot, self.Rot2.minRot, 3, self.Rot2.rotTime*2, dt, false);
			    setRotation(self.Rot2.node, unpack(newRot));
		    end;
		end;
	end;
	if self.hydraulic ~= nil then
		local ax, ay, az = getWorldTranslation(self.hydraulic.node);
		local bx, by, bz = getWorldTranslation(self.hydraulicPoint);
		local x, y, z = worldDirectionToLocal(getParent(self.hydraulic.node), bx-ax, by-ay, bz-az);
		setDirection(self.hydraulic.node, x*-1, y*-1, z*-1, 0, 1, 0);
		if self.hydraulic.punch ~= nil then
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
			setTranslation(self.hydraulic.punch, 0, 0, (distance-self.hydraulic.punchDistance)*-1);
		end;
	end;


  if Input.isKeyPressed(self.keys.fermer) then

		local nearestObject
		local index
	if self.Attacher[1].attachedObject[1] == nil then

       nearestObject,index = ObjectInRange(self);
		self.Attacher[1].objectInRange = nearestObject;
		Object1 = nearestObject;
      
      if self.Attacher[1].objectInRange ~= nil then
         localObject1 = self.Attacher[1].object;
         --setRigidBodyType(self.collision1, "none")
         --setRigidBodyType(self.collision2, "none")
         local x3, y3, z3 = getRotation(self.Rot1.node);
          if y3 < -0.45 then
        

			          
           link(Object1, self.localObject3);
           setTranslation(self.localObject3, 0,0,1);
           setRotation(self.localObject3, 0,0,0);
            
           local gx,gy,gz = getWorldTranslation(Object1);
           local fx,fy,fz = worldToLocal(getParent(localObject1.node), gx,gy,gz);
           setTranslation(localObject1.node, fx, fy, fz);

           local dx, dy, dz = getWorldTranslation(self.localObject3);
           local bx, by, bz = getWorldTranslation(localObject1.node);
           local x, y, z = worldDirectionToLocal(getParent(localObject1.node), dx-bx, dy-by, dz-bz);
           setDirection(localObject1.node, x, y, z, 0, 0, 1);

           setTranslation(self.localObject3, 1,0,0);
           ax,ay,az = getWorldTranslation(self.localObject3);
           local ex, ey, ez = worldToLocal(self.localObject2, ax, ay, az);
          
           
           dist = (ex-1)*(ex-1)+(ey-0)*(ey-0)+(ez-0)*(ez-0);
           dist1 = math.sqrt(dist);
           
           if dist1 > 1.9999 then
          
           dist1 = 2;

           end

           angle1 = (((dist1*dist1)-2)/2);
           
           angle = math.acos((angle1)*-1);
                   
           setRotation(self.localObject2, 0, 0, angle);
           
           local x1,y1,z1= getWorldRotation(self.localObject2);
           local x2,y2,z2= getWorldRotation(Object1);
           if math.floor(z1*100) ~= math.floor(z2*100) then
           setRotation(self.localObject2, 0, 0, angle*-1);
           end;
           
             
			setRigidBodyType(Object1,"none")
			link(self.localObject2, Object1);
            --setRigidBodyType(self.collision1, "none")
			setRotation(Object1, 0, 0, 0);
			setTranslation(Object1, 0,0,0);
			self.Attacher[1].attachedObject[1] = Object1;

			end;
		  end; 
		end;
    end;

   if Input.isKeyPressed(self.keys.fermer) then

		local nearestObject
		local index
	if self.Attacher[2].attachedObject[2] == nil then

       nearestObject,index = ObjectInRange2(self);
		self.Attacher[2].objectInRange = nearestObject;
		Object1 = nearestObject;
      
      if self.Attacher[2].objectInRange ~= nil then
         localObject1 = self.Attacher[2].object;
          local x3, y3, z3 = getRotation(self.Rot1.node);
          if y3 < -0.45 then

			          
           link(Object1, self.localObject5);
           setTranslation(self.localObject5, 0,0,1);
           setRotation(self.localObject5, 0,0,0);
            
           local gx,gy,gz = getWorldTranslation(Object1);
           local fx,fy,fz = worldToLocal(getParent(localObject1.node), gx,gy,gz);
           setTranslation(localObject1.node, fx, fy, fz);

           local dx, dy, dz = getWorldTranslation(self.localObject5);
           local bx, by, bz = getWorldTranslation(localObject1.node);
           local x, y, z = worldDirectionToLocal(getParent(localObject1.node), dx-bx, dy-by, dz-bz);
           setDirection(localObject1.node, x, y, z, 0, 0, 1);

           setTranslation(self.localObject5, 1,0,0);
           ax,ay,az = getWorldTranslation(self.localObject5);
           local ex, ey, ez = worldToLocal(self.localObject4, ax, ay, az);
          
           
           dist = (ex-1)*(ex-1)+(ey-0)*(ey-0)+(ez-0)*(ez-0);
           dist1 = math.sqrt(dist);

           if dist1 > 1.9999 then
          
           dist1 = 2;

           end

           angle1 = (((dist1*dist1)-2)/2);
           angle = math.acos((angle1)*-1);
                   
           setRotation(self.localObject4, 0, 0, angle);
           
           local x1,y1,z1= getWorldRotation(self.localObject4);
           local x2,y2,z2= getWorldRotation(Object1);
           if math.floor(z1*100) ~= math.floor(z2*100) then
           setRotation(self.localObject4, 0, 0, angle*-1);
           end;
           
             
			setRigidBodyType(Object1,"none")
			link(self.localObject4, Object1);
			setRotation(Object1, 0, 0, 0);
			setTranslation(Object1, 0,0,0);
			self.Attacher[2].attachedObject[2] = Object1;

			end;
		  end; 
		end;
    end;
       
    if Input.isKeyPressed(self.keys.fermer) then

		local nearestObject
		local index
	if self.Attacher[3].attachedObject[3] == nil then

       nearestObject,index = ObjectInRange3(self);
		self.Attacher[3].objectInRange = nearestObject;
		Object1 = nearestObject;
      
      if self.Attacher[3].objectInRange ~= nil then
         localObject1 = self.Attacher[3].object;
          local x3, y3, z3 = getRotation(self.Rot1.node);
          if y3 < -0.45 then

			          
           link(Object1, self.localObject7);
           setTranslation(self.localObject7, 0,0,1);
           setRotation(self.localObject7, 0,0,0);
            
           local gx,gy,gz = getWorldTranslation(Object1);
           local fx,fy,fz = worldToLocal(getParent(localObject1.node), gx,gy,gz);
           setTranslation(localObject1.node, fx, fy, fz);

           local dx, dy, dz = getWorldTranslation(self.localObject7);
           local bx, by, bz = getWorldTranslation(localObject1.node);
           local x, y, z = worldDirectionToLocal(getParent(localObject1.node), dx-bx, dy-by, dz-bz);
           setDirection(localObject1.node, x, y, z, 0, 0, 1);

           setTranslation(self.localObject7, 1,0,0);
           ax,ay,az = getWorldTranslation(self.localObject7);
           local ex, ey, ez = worldToLocal(self.localObject6, ax, ay, az);
          
           
           dist = (ex-1)*(ex-1)+(ey-0)*(ey-0)+(ez-0)*(ez-0);
           dist1 = math.sqrt(dist);

           if dist1 > 1.9999 then
          
           dist1 = 2;

           end

           angle1 = (((dist1*dist1)-2)/2);
           angle = math.acos((angle1)*-1);
                   
           setRotation(self.localObject6, 0, 0, angle);
           
           local x1,y1,z1= getWorldRotation(self.localObject6);
           local x2,y2,z2= getWorldRotation(Object1);
           if math.floor(z1*100) ~= math.floor(z2*100) then
           setRotation(self.localObject6, 0, 0, angle*-1);
           end;
           
             
			setRigidBodyType(Object1,"none")
			link(self.localObject6, Object1);
			setRotation(Object1, 0, 0, 0);
			setTranslation(Object1, 0,0,0);
			self.Attacher[3].attachedObject[3] = Object1;

			end;
		  end; 
		end;
    end;

    if Input.isKeyPressed(self.keys.ouvrir) then
      if self.Attacher[1].attachedObject[1] ~= nil then
         local x3, y3, z3 = getRotation(self.Rot1.node);
          if y3 > -0.45 then

        localObject1 = self.Attacher[1].object;
 
        local Object6 = self.Attacher[1].attachedObject[1];

        local x,y,z = getWorldTranslation(Object6);
        local rx,ry,rz = getWorldRotation(Object6);
        setTranslation(Object6, x,y,z);
        setRotation(Object6, rx,ry,rz);
        setRigidBodyType(Object6,"Dynamic")
        link(getRootNode(), Object6);


        link(localObject1.node, self.localObject3);
        setTranslation(self.localObject3, 0,0,0);
        setRotation(self.localObject3, 0,0,0);

        --setRigidBodyType(self.collision1, "none")
        --setRigidBodyType(self.collision2, "none")

        setTranslation(self.localObject2, 0,0,0);
        setRotation(self.localObject2, 0,0,0);
        setTranslation(localObject1.node, 0.9,0,0);
        setRotation(localObject1.node, 0,0,0);

        self.Attacher[1].attachedObject[1] = nil;
     end;
    end;
  end;

 if Input.isKeyPressed(self.keys.ouvrir) then
      if self.Attacher[2].attachedObject[2] ~= nil then
         local x3, y3, z3 = getRotation(self.Rot1.node);
          if y3 > -0.45 then

        localObject1 = self.Attacher[2].object;
 
        local Object6 = self.Attacher[2].attachedObject[2];

        local x,y,z = getWorldTranslation(Object6);
        local rx,ry,rz = getWorldRotation(Object6);
        setTranslation(Object6, x,y,z);
        setRotation(Object6, rx,ry,rz);
        setRigidBodyType(Object6,"Dynamic")
        link(getRootNode(), Object6);


        link(localObject1.node, self.localObject5);
        setTranslation(self.localObject5, 0,0,0);
        setRotation(self.localObject5, 0,0,0);

        --setRigidBodyType(self.collision1, "none")

        setTranslation(self.localObject4, 0,0,0);
        setRotation(self.localObject4, 0,0,0);
        setTranslation(localObject1.node, 0.9,0.7,0);
        setRotation(localObject1.node, 0,0,0);
        setRigidBodyType(self.collision1, "none")

        self.Attacher[2].attachedObject[2] = nil;
     end;
    end;
  end;
    
  if Input.isKeyPressed(self.keys.ouvrir) then
      if self.Attacher[3].attachedObject[3] ~= nil then
         local x3, y3, z3 = getRotation(self.Rot1.node);
          if y3 > -0.45 then

        localObject1 = self.Attacher[3].object;
 
        local Object6 = self.Attacher[3].attachedObject[3];

        local x,y,z = getWorldTranslation(Object6);
        local rx,ry,rz = getWorldRotation(Object6);
        setTranslation(Object6, x,y,z);
        setRotation(Object6, rx,ry,rz);
        setRigidBodyType(Object6,"Dynamic")
        link(getRootNode(), Object6);


        link(localObject1.node, self.localObject7);
        setTranslation(self.localObject7, 0,0,0);
        setRotation(self.localObject7, 0,0,0);

        --setRigidBodyType(self.collision1, "none")

        setTranslation(self.localObject6, 0,0,0);
        setRotation(self.localObject6, 0,0,0);
        setTranslation(localObject1.node, 0.9,1.4,0);
        setRotation(localObject1.node, 0,0,0);

        self.Attacher[3].attachedObject[3] = nil;
     end;
    end;
  end;

end;



function Bugnot_BibalV2:draw()
    
	g_currentMission:addExtraPrintText("Tasto: " .. self.keysDesc.fermer .. " kiudi pinza");
	g_currentMission:addExtraPrintText("Tasto: " .. self.keysDesc.ouvrir .. " apri pinza");

end;

function ObjectInRange(self)
	local nearestObject
	local itemNode
	local index 
	local nearestDistance = 0.5;
	local objectCopy = self.Attacher[1].object;	
	local px, py, pz = getWorldTranslation(objectCopy.node);
	for i=1, table.getn(g_currentMission.itemsToSave) do
	    itemNode = g_currentMission.itemsToSave[i].node;
	    if getParent(g_currentMission.itemsToSave[i].node) == getRootNode() then
		if getUserAttribute(itemNode, "isStrawbale") or getUserAttribute(itemNode, "isHaybale") or getUserAttribute(itemNode, "isRoundHaybale") or getUserAttribute(itemNode, "isRoundStrawbale") then
		local vx, vy, vz = getWorldTranslation(itemNode);
		local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
		    if distance < nearestDistance then
			index = i
			nearestObject = itemNode
			nearestDistance = distance
			end;
			
		end;end
	end;
return nearestObject, index
end;

function ObjectInRange2(self)
	local nearestObject
	local itemNode
	local index 
	local nearestDistance = 0.5;
	local objectCopy = self.Attacher[2].object;	
	local px, py, pz = getWorldTranslation(objectCopy.node);
	for i=1, table.getn(g_currentMission.itemsToSave) do
	    itemNode = g_currentMission.itemsToSave[i].node;
	    if getParent(g_currentMission.itemsToSave[i].node) == getRootNode() then
		if getUserAttribute(itemNode, "isStrawbale") or getUserAttribute(itemNode, "isHaybale") or getUserAttribute(itemNode, "isRoundHaybale") or getUserAttribute(itemNode, "isRoundStrawbale") then
		local vx, vy, vz = getWorldTranslation(itemNode);
		local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
		    if distance < nearestDistance then
			index = i
			nearestObject = itemNode
			nearestDistance = distance
			end;
			
		end;end
	end;
return nearestObject, index
end;

function ObjectInRange3(self)
	local nearestObject
	local itemNode
	local index 
	local nearestDistance = 0.5;
	local objectCopy = self.Attacher[3].object;	
	local px, py, pz = getWorldTranslation(objectCopy.node);
	for i=1, table.getn(g_currentMission.itemsToSave) do
	    itemNode = g_currentMission.itemsToSave[i].node;
	    if getParent(g_currentMission.itemsToSave[i].node) == getRootNode() then
		if getUserAttribute(itemNode, "isStrawbale") or getUserAttribute(itemNode, "isHaybale") or getUserAttribute(itemNode, "isRoundHaybale") or getUserAttribute(itemNode, "isRoundStrawbale") then
		local vx, vy, vz = getWorldTranslation(itemNode);
		local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
		    if distance < nearestDistance then
			index = i
			nearestObject = itemNode
			nearestDistance = distance
			end;
			
		end;end
	end;
return nearestObject, index
end;

